mod Maux logic: 'cl'

incl Mtex

incl Mtexbt

rem 
  \para \bf  Binary trees.  \end 

rem 
  \para \it  Arithmetization.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \it  Membership in binary trees.  \end 

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,Nd(y,l,r)) <- x = y
  Inbt(x,Nd(y,l,r)) <- x != y & Inbt(x,l)
  Inbt(x,Nd(y,l,r)) <- x != y & ~Inbt(x,l) & Inbt(x,r)

thm Inbt_e
  ~Inbt(x,E)
proof  proved.

thm Inbt_nd
  Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
proof 
 cut x = y
  proved
  cut Inbt(x,l)
   proved
   proved...

rem 
  \para \it  Subtrees.  \end 

pred/2 Subtree 'Tex_p2_bt_subtree'
  Subtree(t1,t2) <- t1 = t2
  Subtree(t1,t2) <- t1 != t2 & t2 = Nd(x2,l2,r2) & Subtree(t1,l2)
  Subtree(t1,t2) <- 
    t1 != t2 & t2 = Nd(x2,l2,r2) & ~Subtree(t1,l2) & Subtree(t1,r2)

thm Subtree_right_e
  Subtree(t,E) <-> t = E
proof 
 cut t = E
  proved
  proved..

thm Subtree_right_nd
  Subtree(t,Nd(x,l,r)) <-> t = Nd(x,l,r) \/ Subtree(t,l) \/ Subtree(t,r)
proof 
 cut t = Nd(x,l,r)
  proved
  cut Subtree(t,l)
   proved
   proved...

rem 
  \para \bf  Binary search trees.  \end 

rem 
  \para \it  Tree comparision predicates.  \end 

pred/2 Lt 'Tex_p2_bt_lt'
  Lt(x,t) <-> \a y(Inbt(y,t) -> x < y)

thm Lt_e
  Lt(x,E)
proof 
 exp Lt; x,E proved..

thm Lt_nd
  Lt(x,Nd(y,l,r)) <-> x < y & Lt(x,l) & Lt(x,r)
proof 
 exp Lt; x,r
  exp Lt; x,l
   exp Lt; x,Nd(y,l,r)
    split* \a y1(Inbt(y1,Nd(y,l,r)) -> x < y1) <-> 
           x < y & \a y1(Inbt(y1,l) -> x < y1) & \a y1(Inbt(y1,r) -> x < y1).2,
                                                                             (1,
                                                                              0,
                                                                              4,
                                                                              0,
                                                                              0,
                                                                              0,
                                                                              0),
                                                                             0
     inst \a y1(Inbt(y1,Nd(y,l,r)) -> x < y1); y proved.
     eigen* \a y1(Inbt(y1,l) -> x < y1).0; y1
      inst \a y1(Inbt(y1,Nd(y,l,r)) -> x < y1); y1
       use Inbt_nd.2,1,1,(4,1,0),0; y1; y; l; r proved...
     eigen* \a y1(Inbt(y1,r) -> x < y1).0; y1
      inst \a y1(Inbt(y1,Nd(y,l,r)) -> x < y1); y1
       use Inbt_nd.2,1,1,(4,2,0),0; y1; y; l; r proved...
     eigen* \a y1(Inbt(y1,Nd(y,l,r)) -> x < y1).0; y1
      use Inbt_nd.2,0,0; y1; y; l; r
       weak Inbt(y1,Nd(y,l,r))
        split y1 = y \/ Inbt(y1,l) \/ Inbt(y1,r).4,0,0,0,0
         proved
         inst \a y1(Inbt(y1,l) -> x < y1); y1 proved.
         inst \a y1(Inbt(y1,r) -> x < y1); y1 proved..........

thm Lt_mono
  x <= y & Lt(y,t) -> Lt(x,t)
proof 
 exp Lt; x,t
  eigen* \a y1(Inbt(y1,t) -> x < y1).0; y1
   use Lt.2,0,0:0,2,1,0; y; t; y1 proved....

pred/2 Gt 'Tex_p2_bt_gt'
  Gt(x,t) <-> \a y(Inbt(y,t) -> x > y)

thm Gt_e
  Gt(x,E)
proof 
 exp Gt; x,E proved..

thm Gt_nd
  Gt(x,Nd(y,l,r)) <-> x > y & Gt(x,l) & Gt(x,r)
proof 
 exp Gt; x,r
  exp Gt; x,l
   exp Gt; x,Nd(y,l,r)
    split* \a y1(Inbt(y1,Nd(y,l,r)) -> x > y1) <-> 
           x > y & \a y1(Inbt(y1,l) -> x > y1) & \a y1(Inbt(y1,r) -> x > y1).2,
                                                                             (1,
                                                                              0,
                                                                              4,
                                                                              0,
                                                                              0,
                                                                              0,
                                                                              0),
                                                                             0
     inst \a y1(Inbt(y1,Nd(y,l,r)) -> x > y1); y proved.
     eigen* \a y1(Inbt(y1,l) -> x > y1).0; y1
      inst \a y1(Inbt(y1,Nd(y,l,r)) -> x > y1); y1
       use Inbt_nd.2,1,1,(4,1,0),0; y1; y; l; r proved...
     eigen* \a y1(Inbt(y1,r) -> x > y1).0; y1
      inst \a y1(Inbt(y1,Nd(y,l,r)) -> x > y1); y1
       use Inbt_nd.2,1,1,(4,2,0),0; y1; y; l; r proved...
     eigen* \a y1(Inbt(y1,Nd(y,l,r)) -> x > y1).0; y1
      use Inbt_nd.2,0,0; y1; y; l; r
       weak Inbt(y1,Nd(y,l,r))
        split y1 = y \/ Inbt(y1,l) \/ Inbt(y1,r).4,0,0,0,0
         proved
         inst \a y1(Inbt(y1,l) -> x > y1); y1 proved.
         inst \a y1(Inbt(y1,r) -> x > y1); y1 proved..........

thm Gt_mono
  x >= y & Gt(y,t) -> Gt(x,t)
proof 
 exp Gt; x,t
  eigen* \a y1(Inbt(y1,t) -> x > y1).0; y1
   use Gt.2,0,0:0,2,1,0; y; t; y1 proved....

pred/2 Ltb 'Tex_p2_bt_ltb'
  Ltb(t1,t2) <-> \a x1\a x2(Inbt(x1,t1) & Inbt(x2,t2) -> x1 < x2)

thm Ltb_e_left
  Ltb(E,t2)
proof 
 exp Ltb; E,t2 proved..

thm Ltb_nd_left
  Ltb(Nd(x1,l1,r1),t2) <-> Lt(x1,t2) & Ltb(l1,t2) & Ltb(r1,t2)
proof 
 exp Ltb; r1,t2
  exp Ltb; l1,t2
   exp Lt; x1,t2
    exp Ltb; Nd(x1,l1,r1),t2
     split* \a x2(Inbt(x2,Nd(x1,l1,r1)) -> \a x3(Inbt(x3,t2) -> x2 < x3)) <-> 
            \a y(Inbt(y,t2) -> x1 < y) & 
            \a x2(Inbt(x2,l1) -> \a x3(Inbt(x3,t2) -> x2 < x3)) & 
            \a x2(Inbt(x2,r1) -> \a x3(Inbt(x3,t2) -> x2 < x3)).2,
                                                                (1,0,4,0,0,0,0),
                                                                0
      eigen* \a y(Inbt(y,t2) -> x1 < y).0; y
       inst \a x2(Inbt(x2,Nd(x1,l1,r1)) -> \a x3(Inbt(x3,t2) -> x2 < x3)):0,2,1,0; x1; y proved..
      eigen* \a x2(Inbt(x2,l1) -> \a x3(Inbt(x3,t2) -> x2 < x3)).0:0,2,1,0; x2,
                                                                            x3
       inst \a x2(Inbt(x2,Nd(x1,l1,r1)) -> \a x3(Inbt(x3,t2) -> x2 < x3)):0,2,1,0; x2; x3
        use Inbt_nd.2,1,1,(4,1,0),0; x2; x1; l1; r1 proved...
      eigen* \a x2(Inbt(x2,r1) -> \a x3(Inbt(x3,t2) -> x2 < x3)).0:0,2,1,0; x2,
                                                                            x3
       inst \a x2(Inbt(x2,Nd(x1,l1,r1)) -> \a x3(Inbt(x3,t2) -> x2 < x3)):0,2,1,0; x2; x3
        use Inbt_nd.2,1,1,(4,2,0),0; x2; x1; l1; r1 proved...
      eigen* \a x2(Inbt(x2,Nd(x1,l1,r1)) -> \a x3(Inbt(x3,t2) -> x2 < x3)).0:0,
                                                                             2,
                                                                             1,
                                                                             0; x2,
                                                                                x3
       use Inbt_nd.2,0,0; x2; x1; l1; r1
        weak Inbt(x2,Nd(x1,l1,r1))
         split x2 = x1 \/ Inbt(x2,l1) \/ Inbt(x2,r1).4,0,0,0,0
          inst \a y(Inbt(y,t2) -> x1 < y); x3 proved.
          inst \a x2(Inbt(x2,l1) -> \a x3(Inbt(x3,t2) -> x2 < x3)):0,2,1,0; x2; x3 proved.
          inst \a x2(Inbt(x2,r1) -> \a x3(Inbt(x3,t2) -> x2 < x3)):0,2,1,0; x2; x3 proved...........

thm Ltb_e_right
  Ltb(t1,E)
proof 
 exp Ltb; t1,E proved..

thm Ltb_nd_right
  Ltb(t1,Nd(x2,l2,r2)) <-> Gt(x2,t1) & Ltb(t1,l2) & Ltb(t1,r2)
proof 
 exp Ltb; t1,r2
  exp Ltb; t1,l2
   exp Gt; x2,t1
    exp Ltb; t1,Nd(x2,l2,r2)
     split* \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,Nd(x2,l2,r2)) -> x1 < x3)) <-> 
            \a y(Inbt(y,t1) -> x2 > y) & 
            \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,l2) -> x1 < x3)) & 
            \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,r2) -> x1 < x3)).2,
                                                                (1,0,4,0,0,0,0),
                                                                0
      eigen* \a y(Inbt(y,t1) -> x2 > y).0; y
       inst \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,Nd(x2,l2,r2)) -> x1 < x3)):0,2,1,0; y; x2 proved..
      eigen* \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,l2) -> x1 < x3)).0:0,2,1,0; y,
                                                                            z
       inst \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,Nd(x2,l2,r2)) -> x1 < x3)):0,2,1,0; y; z
        use Inbt_nd.2,1,1,(4,1,0),0; z; x2; l2; r2 proved...
      eigen* \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,r2) -> x1 < x3)).0:0,2,1,0; y,
                                                                            z
       inst \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,Nd(x2,l2,r2)) -> x1 < x3)):0,2,1,0; y; z
        use Inbt_nd.2,1,1,(4,2,0),0; z; x2; l2; r2 proved...
      eigen* \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,Nd(x2,l2,r2)) -> x1 < x3)).0:0,
                                                                             2,
                                                                             1,
                                                                             0; y,
                                                                                z
       use Inbt_nd.2,0,0; z; x2; l2; r2
        weak Inbt(z,Nd(x2,l2,r2))
         split z = x2 \/ Inbt(z,l2) \/ Inbt(z,r2).4,0,0,0,0
          inst \a y(Inbt(y,t1) -> x2 > y); y proved.
          inst \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,l2) -> x1 < x3)):0,2,1,0; y; z proved.
          inst \a x1(Inbt(x1,t1) -> \a x3(Inbt(x3,r2) -> x1 < x3)):0,2,1,0; y; z proved...........

thm Ltb_lt
  Ltb(t1,t2) & Inbt(x,t1) -> Lt(x,t2)
proof 
 exp Lt; x,t2
  eigen* \a y(Inbt(y,t2) -> x < y).0; y
   use Ltb.2,0,0:0,2,1,0; t1; t2; x; y proved....

thm Ltb_gt
  Ltb(t1,t2) & Inbt(x,t2) -> Gt(x,t1)
proof 
 exp Gt; x,t1
  eigen* \a y(Inbt(y,t1) -> x > y).0; y
   use Ltb.2,0,0:0,2,1,0; t1; t2; y; x proved....

thm Ltb_gt_lt
  Gt(x,t1) & Lt(x,t2) -> Ltb(t1,t2)
proof 
 exp Ltb; t1,t2
  eigen* \a x1(Inbt(x1,t1) -> \a x2(Inbt(x2,t2) -> x1 < x2)).0:0,2,1,0; x1,x2
   use Gt.2,0,0:0,2,1,0; x; t1; x1
    use Lt.2,0,0:0,2,1,0; x; t2; x2 proved.....

rem 
  \para \it  Binary search trees.  \end 

pred Bst 
  Bst(t) <-> Bt(t) & \a x\a l\a r(Subtree(Nd(x,l,r),t) -> Gt(x,l) & Lt(x,r))

thm Bst_e
  Bst(E)
proof 
 exp Bst; E proved..

thm Bst_nd
  Bst Nd(x,l,r) <-> Gt(x,l) & Lt(x,r) & Bst(l) & Bst(r)
proof 
 split* Bst Nd(x,l,r) <-> Gt(x,l) & Lt(x,r) & Bst(l) & Bst(r).2,
                                                              (1,0,4,0,0,0,0,0),
                                                              0
  use Bst.2,0,1,0,4,1,1,0,4,0,0:0,2,1,0; Nd(x,l,r); x; l; r proved.
  use Bst.2,0,1,0,4,1,1,0,4,1,0:0,2,1,0; Nd(x,l,r); x; l; r proved.
  exp Bst; l
   split* Bt(l) & 
          \a x1\a l1\a r1(Subtree(Nd(x1,l1,r1),l) -> Gt(x1,l1) & Lt(x1,r1)).4,0,
                                                                            0,0
    use Bst.2,0,1,0,4,0,0; Nd(x,l,r) proved.
    eigen* \a x1\a l1\a r1(Subtree(Nd(x1,l1,r1),l) -> Gt(x1,l1) & Lt(x1,r1)).0; x1,
                                                                                l1,
                                                                                r1
     use Bst.2,0,1,0,4,1,0:0,2,1,0; Nd(x,l,r); x1; l1; r1
      use Subtree_right_nd.2,1,1,(4,1,0),0; Nd(x1,l1,r1); x; l; r proved.....
  exp Bst; r
   split* Bt(r) & 
          \a x1\a l1\a r1(Subtree(Nd(x1,l1,r1),r) -> Gt(x1,l1) & Lt(x1,r1)).4,0,
                                                                            0,0
    use Bst.2,0,1,0,4,0,0; Nd(x,l,r) proved.
    eigen* \a x1\a l1\a r1(Subtree(Nd(x1,l1,r1),r) -> Gt(x1,l1) & Lt(x1,r1)).0; x1,
                                                                                l1,
                                                                                r1
     use Bst.2,0,1,0,4,1,0:0,2,1,0; Nd(x,l,r); x1; l1; r1
      use Subtree_right_nd.2,1,1,(4,2,0),0; Nd(x1,l1,r1); x; l; r proved.....
  exp Bst; Nd(x,l,r)
   split* Bt(l) & Bt(r) & 
          \a x1\a l1\a r1(Subtree(Nd(x1,l1,r1),Nd(x,l,r)) -> 
                          Gt(x1,l1) & Lt(x1,r1)).4,0,0,0,0
    use Bst.2,0,1,0,4,0,0; l proved.
    use Bst.2,0,1,0,4,0,0; r proved.
    eigen* \a x1\a l1\a r1(Subtree(Nd(x1,l1,r1),Nd(x,l,r)) -> 
                           Gt(x1,l1) & Lt(x1,r1)).0; x1,l1,r1
     use Subtree_right_nd.2,0,0; Nd(x1,l1,r1); x; l; r
      weak Subtree(Nd(x1,l1,r1),Nd(x,l,r))
       split x1 = x & l1 = l & r1 = r \/ Subtree(Nd(x1,l1,r1),l) \/ 
             Subtree(Nd(x1,l1,r1),r).4,0,0,0,0
        proved
        use Bst.2,0,1,0,4,1,0:0,2,1,0; l; x1; l1; r1 proved.
        use Bst.2,0,1,0,4,1,0:0,2,1,0; r; x1; l1; r1 proved.........

thm Bst_inbt_left_lt
  Bst Nd(x,l,r) & Inbt(y,l) -> y < x
proof 
 use Bst_nd.2,0,0; x; l; r
  weak Bst Nd(x,l,r); Lt(x,r); Bst(l); Bst(r)
   use Gt.2,0,0:0,2,1,0; x; l; y proved....

thm Bst_inbt_right_gt
  Bst Nd(x,l,r) & Inbt(y,r) -> y > x
proof 
 use Bst_nd.2,0,0; x; l; r
  weak Bst Nd(x,l,r); Gt(x,l); Bst(l); Bst(r)
   use Lt.2,0,0:0,2,1,0; x; r; y proved....

thm Bst_ltb
  Bst Nd(x,l,r) -> Ltb(l,r)
proof 
 use Bst_nd.2,0,0; x; l; r
  use Ltb_gt_lt; x; l; r proved...

thm Bst_inbt_ltb
  Bst Nd(x,l,r) & Inbt(y,l) & Inbt(z,r) -> y < z
proof 
 use Bst_ltb; x; l; r
  use Ltb.2,0,0:0,2,1,0; l; r; y; z proved...

